// troxengine
// routines for displaying and drawing, the "important" part
// last change 1999-01-02
// Robin Gruber

#ifndef TROXENGINE_H
#define TROXENGINE_H

#include <vga.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "troxmath.h"

#define WIDTH 640
#define HIGHT 320
#define DEPTH 320
#define BIGBALLRADIUS 128 
#define STATUSHIGHT 160
#define SMALLBALLRADIUS 12
#define MAXRADIUS 20
#define MINRADIUS 3
#define TEXTBALL1RADIUS 12
#define TEXTBALL2RADIUS 2

#define PALECOLOR // put in <<2 here if you got pale colors!

void displayimage(void);

void displaystatus(void);

void clearimage(void);

void clearstatusarea(void);

void setpalette(const int & i, const int & r, const int & g, const int & b);

void setblack(const int & c);

void createpalette(void);

void generatetextballs(int radius1,int radius2);

void setsmallballradius(int radius);

void outtextxy(signed int x, signed int y, char * text);

void doneengine(void);

void initengine();

void drawsmallball(signed short const & x, signed short const & y, 
		   signed short const & z, unsigned char const & c, int const & side);

void drawdemoball(signed short const & x, signed short const & y, 
		  signed short const & z, unsigned char const & c);

void fadepal(const int & fade);

int getsmallballradius(void);

void fadeout(void);

void fadein(void);

void greyin(void);

void greyout(void);

void showpal(void);


#endif
